package com.heaton.forum;
import javax.servlet.jsp.*;
import javax.servlet.jsp.tagext.*;
import java.util.*;
import java.io.*;
import org.apache.taglibs.standard.tag.el.core.*;
import java.sql.*;

/**
 * Example program from Chapter 11
 * JSTL: JSP Standard Template Library
 * Published by Sams Publishing
 *
 *
 * This file implements the listForums tag for the
 * forum custom tag library example.
 *
 * @author Jeff Heaton(http://www.jeffheaton.com)
 * @version 1.0
 */

public class ListForumsTag extends TagSupport {
  private String var;
  private String scope;

  public void setVar(String var) {
    this.var = var;
  }

  public void setScope(String scope) {
    this.scope = scope;
  }

  /**
   * The start of the tag, used to process the EL
   * expressions.
   * 
   * @return A status to indicate if the body is to be 
   * processed. Here the body is not processed.
   * @exception javax.servlet.jsp.JspException Thrown on general error.
   */
  public int doStartTag()
  throws  javax.servlet.jsp.JspException
  {
    return SKIP_BODY;
  }

  /**
   * The ending tag method is called when the tag
   * is ready to complete. It is here that
   * the forums are listed.
   * 
   * @return A status code that indicates if the rest of the
   * page is to be processed. 
   * @exception JspException Thrown on general error.
   */
  public int doEndTag() throws JspException {
    Session session = Session.getSession(pageContext);
    Collection list = session.listForums();
    pageContext.setAttribute(var,list,Session.getScope(scope));
    return EVAL_PAGE;
  }
}
