package com.heaton.forum;
import javax.servlet.jsp.*;
import javax.servlet.jsp.tagext.*;
import java.util.*;
import java.io.*;
import org.apache.taglibs.standard.tag.el.core.*;
import java.sql.*;

/**
 * Example program from Chapter 11
 * JSTL: JSP Standard Template Library
 * Published by Sams Publishing
 *
 *
 * This file implements the newUser tag for the
 * forum custom tag library example.
 *
 * @author Jeff Heaton(http://www.jeffheaton.com)
 * @version 1.0
 */

public class NewUserTag extends TagSupport {
  private String id_el, var, scope;
  private String id;
  private String pw_el,pw;

  public void setId(String id) {
    this.id_el = id;
  }

  public void setVar(String var) {
    this.var = var;
  }

  public void setScope(String scope) {
    this.scope = scope;
  }

  public void setPassword(String password)
  {
    this.pw_el = password;
  }

  /**
   * The start of the tag, used to process the EL
   * expressions.
   * 
   * @return A status to indicate if the body is to be 
   * processed. Here the body is not processed.
   * @exception javax.servlet.jsp.JspException Thrown on general error.
   */
  public int doStartTag()
  throws  javax.servlet.jsp.JspException
  {
    id = (String)ExpressionUtil.evalNotNull(
      "loginUser", "id", id_el, String.class, this, pageContext);

    pw = (String)ExpressionUtil.evalNotNull(
      "loginUser", "pw", pw_el, String.class, this, pageContext);

    return SKIP_BODY;
  }

  /**
   * The ending tag method is called when the tag
   * is ready to complete. It is here that
   * a new user is created.
   * 
   * @return A status code that indicates if the rest of the
   * page is to be processed. 
   * @exception JspException Thrown on general error.
   */
  public int doEndTag() throws JspException {
    Session session = Session.getSession(pageContext);
    User user = session.createUser(id,pw);
    pageContext.setAttribute(var,user,Session.getScope(scope));
    return EVAL_PAGE;
  }
}
